=== debian/changelog ===
insighttoolkit4 (4.6.0-3ubuntu3) vivid; urgency=medium

  * Don't try to use SSE2 on other architectures.
  * Ignore test results on architectures other than amd64 and i386 for
    a first build.
  * Build with -O2 on ppc64el.
  * debian/rules: Use HOST instead of BUILD macros.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 16 Mar 2015 19:02:42 +0100

insighttoolkit4 (4.6.0-3ubuntu1) vivid; urgency=medium

  * Build on all architectures.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 16 Mar 2015 12:42:16 +0100

insighttoolkit4 (4.6.0-3build1) vivid; urgency=medium

  * No-change rebuild for new gdcm

 -- Iain Lane <iain@orangesquash.org.uk>  Wed, 05 Nov 2014 17:19:31 +0000

insighttoolkit4 (4.6.0-3) unstable; urgency=medium

  * rules: Build Module_ITKDeprecated as Elastix 4.7 needs now-deprecated
    itkTransformToDisplacementFieldSource.h.  See #757589.

 -- Steve M. Robbins <smr@debian.org>  Mon, 18 Aug 2014 18:39:28 -0500

insighttoolkit4 (4.6.0-2) unstable; urgency=medium

  * control.in: add libhdf5-dev dep to -dev package.  Closes: #757594.
  Migrate previous control fixes to control.in.

 -- Steve M. Robbins <smr@debian.org>  Mon, 11 Aug 2014 21:55:42 -0500

insighttoolkit4 (4.6.0-1) unstable; urgency=medium

  [ Gert Wollny ]
  * Remove dependency on libdouble-conversion-dev, since it currently 
    can not be used (#756480).
  * Enable use of system hdf5 library.  Closes: #756015
  * Change gccxml dep to 0.9.0+git20140716 to silence lintian warning.
  * Remove patch to increase OtsuThreshold computation precision 
    (added upstream).
  * Remove patch to increase itkVoronoiPartitioningImageFilterTest1 tolerance 
    (added upstream).
  * Revise patch to avoid including emmintr.h when __SSE2__ is not defined.
  * Add debug package.
  * Add patch to not check for the swig_version since it was done before 
    find_package(swig).

  [ Steve M. Robbins ]
  * Prepare upload.

 -- Steve M. Robbins <smr@debian.org>  Sat, 02 Aug 2014 10:37:24 -0500

insighttoolkit4 (4.5.2-4) unstable; urgency=medium

  * Team upload.

  [ Gianfranco Costamagna ]
  * control.in: bump gccxml dep to 0.9.0+git20140716-1 to ensure
    up-to-date support for GCC 4.9.

  [ Gert Wollny ]
  * Add patch to increase OtsuThreshold computation precision
  * Add patch to increase itkVoronoiPartitioningImageFilterTest1 tolerance
  * Add patch to avoid including emmintr.h when __SSE2__ is not defined 

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 16 Jul 2014 12:07:29 +0200

insighttoolkit4 (4.5.2-3) unstable; urgency=medium

  * control.in: bump gccxml dep to 0.9.0+git20140610-2 to ensure
    up-to-date support for GCC 4.9.  Closes: #746863.

 -- Steve M. Robbins <smr@debian.org>  Tue, 01 Jul 2014 16:16:37 -0500

insighttoolkit4 (4.5.2-2) unstable; urgency=medium

  * Bump gccxml dependency to  0.9.0+git20140205 because it seems
    to be required for builds with g++-4.8
  * Add some magic to d/rules to dump the test log to stdout if the
    tests fail

 -- Gert Wollny <gw.fossdev@gmail.com>  Fri, 23 May 2014 14:19:45 +0200

insighttoolkit4 (4.5.2-1) unstable; urgency=medium

  * New upstream.
  
  * patches/0001-BUG-Wrap-TransformFileReader-TransformFileWriter.patch:
  * patches/0002-COMP-Fixed-itkQuasiNewtonOptimizerv4-wrapping-warnin.patch:
  * patches/0003-COMP-Fixed-itkGradientDescentOptimizerv4-wrapping-wa.patch:
  * patches/0004-COMP-Warp-OptimizerParameterScalesEstimatorTemplate.patch:
    Remove; applied upstream.

 -- Steve M. Robbins <smr@debian.org>  Sun, 13 Apr 2014 07:31:59 -0500

insighttoolkit4 (4.5.1-1) unstable; urgency=medium

  [Gert Wollny]
  * new uptream
  * enable python2.7 bindings
  * update build dependencies to new wrapping method
  * Add linker flags --as-needed to reduce dependencies
  * make ITKGDCM a static library since it is only a dependency stub

  [ Steve M. Robbins ]
  * Merged Gert's patches to main trunk for release.

 -- Steve M. Robbins <smr@debian.org>  Sun, 30 Mar 2014 15:43:57 -0500
